--RSS GTM LANZO V10 EVO2 LED
--Made by R_are_L https://twitter.com/R_are_L_

local LED = {}
local TimerPL = 0
local PitLimiter = 0

function update(dt)
	TimerPL = TimerPL + dt*3

	if (car.manualPitsSpeedLimiterEnabled == true) or (car.isInPitlane == true) then --PitLimiter
		PitLimiter = 1
	else
		PitLimiter = 0
	end	

	for i = 0, 9 do
		LED[i] = ac.findNodes("carRoot:" .. car.index):findMeshes("LED_"..i):ensureUniqueMaterials()
        if (car.rpm > 7350+(50*i)) and i <= 9 then
            if i < 4 then
                LED[i]:setMaterialProperty("ksEmissive", vec3(0,125,0))
            elseif i < 6 then
                LED[i]:setMaterialProperty("ksEmissive", vec3(333, 155, 0))
            else
                LED[i]:setMaterialProperty("ksEmissive", vec3(333, 0, 0))
            end
        end
        if car.rpm > 7900 then
            LED[i]:setMaterialProperty("ksEmissive", vec3(0,20,333))
        end

        if PitLimiter == 1 then
            LED[i]:setMaterialProperty("ksEmissive", vec3(0,0,0))
            if i >= 3 and i <= 6 and (math.fmod(math.floor(TimerPL), 2) == 1) then
                LED[i]:setMaterialProperty("ksEmissive", vec3(0,20,333))
            end
        end

	    if car.absInAction and i >= 8 then
	    	LED[i]:setMaterialProperty("ksEmissive", vec3(333, 155, 0))
	    end 

    	if car.tractionControlInAction and i <= 1   then
    		LED[i]:setMaterialProperty("ksEmissive", vec3(0,20,333))
    	end
    end
end