---RSS GTM LUX V8 RaceLogic
--Made by R_are_L https://twitter.com/R_are_L_

local PAGE = 0
local PitLimiter = 0
local LastExtraF = car.extraF

local lap = 0
local PERF = 0
local PERF_P = 0
local SPEED = 0
local SPEED_P = 0
local TimerD = 0
local TimerD_M = 0
local TimerD_S = 0
local TimerD_P = 0
local LAP_TIME_H = 0
local LAP_TIME_M = 0
local LAP_TIME_S = 0
local LAST_LAP_H = 0
local LAST_LAP_M = 0
local LAST_LAP_S = 0

local function initialize()
	display.image{pos=vec2 (-50,-1800) , size = vec2 (4450,5000),image = "assets/RR/P0.png"}
	display.image{pos=vec2 (-50,-1800) , size = vec2 (4450,5000),image = "assets/RR/P1.png"}
	display.image{pos=vec2 (-50,-1800) , size = vec2 (4450,5000),image = "assets/RR/P2.png"}
	display.image{pos=vec2 (-50,-1800) , size = vec2 (4450,5000),image = "assets/RR/PSL.png"}
	
	INITIALIZED = true

end


function update(dt)

	TimerD = TimerD + dt
	SPEED = math.floor(car.speedKmh)
	SPEED_P = string.format("%02d",math.floor(car.speedKmh*100)-(SPEED*100))
	LAP_TIME_M = string.format("%01d",math.floor(((car.lapTimeMs)/(1000*60))%60))
	LAP_TIME_S = string.format("%02d",math.floor(((car.lapTimeMs)/1000)%60))
	LAP_TIME_P = string.format("%01d",math.floor(((car.lapTimeMs)/100)%10))
	LAST_LAP_M = string.format("%01d",math.floor(((car.previousLapTimeMs)/(1000*60))%60))
	LAST_LAP_S = string.format("%02d",math.floor(((car.previousLapTimeMs)/1000)%60))
	LAST_LAP_P = string.format("%01d",math.floor(((car.previousLapTimeMs)/100)%10))
	lap = string.format("%02d",car.lapCount+1)
	TimerD_H = string.format(math.floor((TimerD*1000)/(1000*60*60))%24)
	TimerD_M = string.format("%02d", math.floor((TimerD*1000)/(1000*60))%60)
	TimerD_S = string.format("%02d",(math.floor(TimerD))%60)
	--------------------------------------------------------------------------------------------------------------------

	if (ac.getSim().isInMainMenu) then
		TimerD = 0
	end

	if (car.performanceMeter > 0) then
		PERF = string.format("%02d",math.floor(car.performanceMeter))
		PERF_P = string.format("%02d",math.floor(car.performanceMeter*100)-(math.floor(car.performanceMeter)*100))
	elseif (car.performanceMeter == 0) then
		PERF = "00"
		PERF_P = "00"
	else 
		PERF = "-"..(string.format("%02d",math.floor(car.performanceMeter*-1)))
		PERF_P = string.format("%02d",(math.ceil(car.performanceMeter*100)-(math.ceil(car.performanceMeter)*100))*(-1))
	end

	if (math.abs(car.performanceMeter) > 20) then
		PERF = "--"
		PERF_P = "--"
	end
	

	if (car.lapTimeMs) <= 3000 then
		LAP_TIME_M = LAST_LAP_M
		LAP_TIME_S = LAST_LAP_S
		LAP_TIME_P = LAST_LAP_P

		PERF = LAST_LAP_S
		PERF_P = string.format("%02d",math.floor(((car.previousLapTimeMs)/10)%100))
	end

	if LastExtraF ~= (car.extraF) then
		LastExtraF = (car.extraF)
		if PAGE == 2 then
			PAGE = -1
		end
		PAGE = PAGE +1
	end

	if (car.manualPitsSpeedLimiterEnabled == true) or (car.isInPitlane == true) then --PitLimiter
		PitLimiter = 1
	else
		PitLimiter = 0
	end	

	--------------------------------------------------------------------------------------------------------------------

	if PitLimiter == 0 then
		if PAGE == 0 then
			display.image{pos=vec2 (-50,-1800) , size = vec2 (4450,5000),image = "assets/RR/P0.png"}
			display.text{pos= vec2 (3610,750) , letter=vec2(220, 650), text=lap, font="rss_gtm_4_regular", spacing =-5,color = rgbm(1, 1, 1, 1), }
			display.text{pos= vec2 (80,-60) , letter=vec2(500, 1700), text=LAP_TIME_M, font="rss_gtm_4_regular", spacing =-5,color = rgbm(1, 1, 1, 1), width = 1100, alignment = 1 }
			display.text{pos= vec2 (1400,-60) , letter=vec2(500, 1700), text=LAP_TIME_S, font="rss_gtm_4_regular", spacing =-5,color = rgbm(1, 1, 1, 1)}
			display.text{pos= vec2 (2600,-60) , letter=vec2(500, 1700), text=LAP_TIME_P, font="rss_gtm_4_regular", spacing =-5,color = rgbm(1, 1, 1, 1) }
			display.text{pos= vec2 (1100,-40) , letter=vec2(500, 1700), text=":  .", font="rss_gtm_4_regular", spacing =-120,color = rgbm(1, 1, 1, 1) }
		elseif PAGE == 1 then
			display.image{pos=vec2 (-50,-1800) , size = vec2 (4450,5000),image = "assets/RR/P1.png"}
			display.rect{pos= vec2 (2150,1030) , size = vec2(2000*(car.performanceMeter/2.5),200),color = rgbm(1, 1, 1, 1) }
				display.text{pos= vec2 (1230,80) , letter=vec2(300, 900), text=PERF, font="rss_gtm_4_regular", spacing =-5,color = rgbm(1, 1, 1, 1), width = 900, alignment = 1  }
			display.text{pos= vec2 (2200,80) , letter=vec2(300, 900), text=PERF_P, font="rss_gtm_4_regular", spacing =-5,color = rgbm(1, 1, 1, 1) }
			display.text{pos= vec2 (2000,260) , letter=vec2(300, 700), text=".", font="rss_gtm_4_regular", spacing =-5,color = rgbm(1, 1, 1, 1) }
		elseif PAGE == 2 then
			display.image{pos=vec2 (-50,-1800) , size = vec2 (4450,5000),image = "assets/RR/P2.png"}
			display.text{pos= vec2 (100,-105) , letter=vec2(550, 1800), text=TimerD_H, font="rss_gtm_4_regular", spacing =-5,color = rgbm(1, 1, 1, 1)}
			display.text{pos= vec2 (750,-105) , letter=vec2(550, 1800), text=TimerD_M, font="rss_gtm_4_regular", spacing =-5,color = rgbm(1, 1, 1, 1)}
			display.text{pos= vec2 (1950,-105) , letter=vec2(550, 1800), text=TimerD_S, font="rss_gtm_4_regular", spacing =-5,color = rgbm(1, 1, 1, 1)}
			display.text{pos= vec2 (500,-135) , letter=vec2(550, 1800), text=": :", font="rss_gtm_4_regular", spacing =50,color = rgbm(1, 1, 1, 1)}
		end
	else
		display.image{pos=vec2 (-50,-1800) , size = vec2 (4450,5000),image = "assets/RR/PSL.png"}
		display.text{pos= vec2 (900,-105) , letter=vec2(550, 1800), text=SPEED, font="rss_gtm_4_regular", spacing =-5,color = rgbm(1, 1, 1, 1), width = 1100, alignment = 1 }
		display.text{pos= vec2 (1770,450) , letter=vec2(550, 1000), text=".", font="rss_gtm_4_regular", spacing =-5,color = rgbm(1, 1, 1, 1)}
		display.text{pos= vec2 (2100,-105) , letter=vec2(550, 1800), text=SPEED_P, font="rss_gtm_4_regular", spacing =-5,color = rgbm(1, 1, 1, 1)}
	end

	if not INITIALIZED then initialize() end
end