--RSS GTM MERCER V8 LED
--Made by R_are_L https://twitter.com/R_are_L_

local TimerPL = 0
local TimerPL2 = 0
local TimerRPM = 0
local PitLimiter = 0
local LED_0 = ac.findNodes("carRoot:" .. car.index):findMeshes("LED_0"):ensureUniqueMaterials()
local LED_1 = ac.findNodes("carRoot:" .. car.index):findMeshes("LED_1"):ensureUniqueMaterials()
local LED_2 = ac.findNodes("carRoot:" .. car.index):findMeshes("LED_2"):ensureUniqueMaterials()
local LED_3 = ac.findNodes("carRoot:" .. car.index):findMeshes("LED_3"):ensureUniqueMaterials()
local LED_4 = ac.findNodes("carRoot:" .. car.index):findMeshes("LED_4"):ensureUniqueMaterials()
local LED_5 = ac.findNodes("carRoot:" .. car.index):findMeshes("LED_40"):ensureUniqueMaterials()
local LED_6 = ac.findNodes("carRoot:" .. car.index):findMeshes("LED_30"):ensureUniqueMaterials()
local LED_7 = ac.findNodes("carRoot:" .. car.index):findMeshes("LED_20"):ensureUniqueMaterials()
local LED_RAIN_MASK = ac.findNodes("carRoot:" .. car.index):findMeshes("GEO_RAINLIGHT_MASK"):ensureUniqueMaterials()
local LED_RAIN = ac.findNodes("carRoot:" .. car.index):findMeshes("GEO_RAINLIGHT_BULBS_SUB0"):ensureUniqueMaterials()

function update(dt)
	
	if (car.manualPitsSpeedLimiterEnabled == true) or (car.isInPitlane == true) then --PitLimiter
		PitLimiter = 1
	else
		PitLimiter = 0
	end


	if car.rpm <= 7150 then
		TimerRPM = 0
		if car.rpm >= 5950 then
			LED_0:setMaterialProperty("ksEmissive", vec3(0, 333, 0))
		else
			LED_0:setMaterialProperty("ksEmissive", vec3(0, 0, 0))
		end

		if car.rpm >= 6250 then
			LED_1:setMaterialProperty("ksEmissive", vec3(0, 333, 0))
		else
			LED_1:setMaterialProperty("ksEmissive", vec3(0, 0, 0))
		end

		if car.rpm >= 6550 then
			LED_2:setMaterialProperty("ksEmissive", vec3(333, 155, 0))
			LED_7:setMaterialProperty("ksEmissive", vec3(333, 155, 0))
		else
			LED_2:setMaterialProperty("ksEmissive", vec3(0, 0, 0))
			LED_7:setMaterialProperty("ksEmissive", vec3(0, 0, 0))
		end

		if car.rpm >= 6750 then
			LED_3:setMaterialProperty("ksEmissive", vec3(333, 155, 0))
				LED_6:setMaterialProperty("ksEmissive", vec3(333, 155, 0))
		else
			LED_3:setMaterialProperty("ksEmissive", vec3(0, 0, 0))
			LED_6:setMaterialProperty("ksEmissive", vec3(0, 0, 0))
		end

		if car.rpm >= 6950 then
			LED_4:setMaterialProperty("ksEmissive", vec3(333, 0, 0))
			LED_5:setMaterialProperty("ksEmissive", vec3(333, 0, 0))
		else
			LED_4:setMaterialProperty("ksEmissive", vec3(0, 0, 0))
			LED_5:setMaterialProperty("ksEmissive", vec3(0, 0, 0))
		end

	else
		TimerRPM = TimerRPM + dt*5
		LED_0:setMaterialProperty("ksEmissive", vec3(333, 0, 0))
		LED_1:setMaterialProperty("ksEmissive", vec3(333, 0, 0))
		LED_2:setMaterialProperty("ksEmissive", vec3(333, 0, 0))
		LED_3:setMaterialProperty("ksEmissive", vec3(333, 0, 0))
		LED_4:setMaterialProperty("ksEmissive", vec3(333, 0, 0))
		LED_5:setMaterialProperty("ksEmissive", vec3(333, 0, 0))
		LED_6:setMaterialProperty("ksEmissive", vec3(333, 0, 0))
		LED_7:setMaterialProperty("ksEmissive", vec3(333, 0, 0))
		if math.fmod(math.floor(TimerRPM), 2) == 0 then
			LED_0:setMaterialProperty("ksEmissive", vec3(0, 0, 0))
			LED_1:setMaterialProperty("ksEmissive", vec3(0, 0, 0))
			LED_2:setMaterialProperty("ksEmissive", vec3(0, 0, 0))
			LED_3:setMaterialProperty("ksEmissive", vec3(0, 0, 0))
			LED_4:setMaterialProperty("ksEmissive", vec3(0, 0, 0))
			LED_5:setMaterialProperty("ksEmissive", vec3(0, 0, 0))
			LED_6:setMaterialProperty("ksEmissive", vec3(0, 0, 0))
			LED_7:setMaterialProperty("ksEmissive", vec3(0, 0, 0))
		end
	end

	if car.absInAction then
		LED_3:setMaterialProperty("ksEmissive", vec3(0,20,333))
		LED_4:setMaterialProperty("ksEmissive", vec3(0,20,333))
		LED_5:setMaterialProperty("ksEmissive", vec3(0,20,333))
		LED_6:setMaterialProperty("ksEmissive", vec3(0,20,333))
	end

	if car.extraA then
		LED_RAIN:setMaterialProperty("ksEmissive", vec3(7500, 15, 15))
		LED_RAIN_MASK:setMaterialProperty("ksEmissive", vec3(5, 0, 0))
	else 
		LED_RAIN:setMaterialProperty("ksEmissive", vec3(0, 0, 0))
		LED_RAIN_MASK:setMaterialProperty("ksEmissive", vec3(0, 0, 0))
	end

	if PitLimiter == 1 then
		TimerPL = TimerPL + dt*4
		TimerPL2 = TimerPL2 + dt*3
		LED_RAIN:setMaterialProperty("ksEmissive", vec3(7500, 15, 15))
		LED_RAIN_MASK:setMaterialProperty("ksEmissive", vec3(5, 0, 0))
		if math.fmod(math.floor(TimerPL), 2) == 1 then
			LED_RAIN:setMaterialProperty("ksEmissive", vec3(0, 0, 0))
			LED_RAIN_MASK:setMaterialProperty("ksEmissive", vec3(0, 0, 0))
		end

		LED_0:setMaterialProperty("ksEmissive", vec3(0, 333, 0))
		LED_1:setMaterialProperty("ksEmissive", vec3(0, 0, 0))
		LED_2:setMaterialProperty("ksEmissive", vec3(333, 0, 0))
		LED_3:setMaterialProperty("ksEmissive", vec3(0,20,333))
		LED_4:setMaterialProperty("ksEmissive", vec3(333, 0, 0))
		LED_5:setMaterialProperty("ksEmissive", vec3(0,20,333))
		LED_6:setMaterialProperty("ksEmissive", vec3(333, 0, 0))
		LED_7:setMaterialProperty("ksEmissive", vec3(0,20,333))
		if math.fmod(math.floor(TimerPL2), 2) == 1 then
			LED_0:setMaterialProperty("ksEmissive", vec3(0, 0, 0))
			LED_1:setMaterialProperty("ksEmissive", vec3(0, 333, 0))
			LED_2:setMaterialProperty("ksEmissive", vec3(0,20,333))
			LED_3:setMaterialProperty("ksEmissive", vec3(333, 0, 0))
			LED_4:setMaterialProperty("ksEmissive", vec3(0,20,333))
			LED_5:setMaterialProperty("ksEmissive", vec3(333, 0, 0))
			LED_6:setMaterialProperty("ksEmissive", vec3(0,20,333))
			LED_7:setMaterialProperty("ksEmissive", vec3(333, 0, 0))
		end
	else
		TimerPL = 0
		TimerPL2 = 0
	end

end
