--RSS GTM MERCER V8 MFD
--Made by R_are_L https://twitter.com/R_are_L_

local slip = 0
local slip_f = 0
local TC = car.tractionControlMode
local ABS = car.absMode
local POP = 0
local fpl = 0
local fpl_p = 0
local rpm = 0
local fuel = 0
local fuel_p = 0
local laps = 0
local page = 0
local SPEED = 0
local SPEED_P = 0
local Hours = 0
local Minutes = 0
local Seconds = 0
local W_TEMP = 0
local OIL_TEMP = 0
local PERF = 0
local PERF_P = 0
local TimerPOP = 0
local TimerBB = 0
local lastBB = car.brakeBias
local brakeBias = 0
local brakeBias_P = 0
local PitLimiter = 0
local LAP_TIME_M = 0
local LAP_TIME_S = 0
local LAP_TIME_P = 0
local LAST_LAP_M = 0
local LAST_LAP_S = 0
local LAST_LAP_P = 0
local TYRE_PRES_LF = 0
local TYRE_PRES_RF = 0
local TYRE_PRES_LR = 0
local TYRE_PRES_RR = 0
local TYRE_PRES_LF_P = 0
local TYRE_PRES_RF_P = 0
local TYRE_PRES_LR_P = 0
local TYRE_PRES_RR_P = 0

local function initialize()

	display.image{image = "assets/MFD/PAGE_0.png",pos = vec2(0,0), size = vec2(8192,8192)}
	display.image{image = "assets/MFD/PAGE_1.png",pos = vec2(0,0), size = vec2(8192,8192)}
	display.image{image = "assets/MFD/POPUP_LowBeam.png",pos = vec2(4030,6350), size = vec2(968,728)}
	display.image{image = "assets/MFD/POPUP_HighBeam.png",pos = vec2(5220,6390), size = vec2(968,728)}
	display.image{image = "assets/MFD/POPUP_Indicator.png",pos = vec2(2720,6470), size = vec2(536,552)}
	display.image{image = "assets/MFD/POPUP_Indicator.png",pos = vec2(3900,6470), size = vec2(-536,552)}
	display.image{image = "assets/MFD/POPUP_ABS.png",pos = vec2(5076, 3600), size = vec2(2992,2616)}
	display.image{image = "assets/MFD/POPUP_TC.png",pos = vec2(5076, 3600), size = vec2(2992,2616)}
	display.image{image = "assets/MFD/POPUP_ABSOff2.png",pos = vec2(3227,3730), size = vec2(1752,2256)}
	display.image{image = "assets/MFD/POPUP_ABSOff.png",pos = vec2(5167,3660), size = vec2(900,1180)}
	display.image{image = "assets/MFD/POPUP_TCOff.png",pos = vec2(6130,3660), size = vec2(900,1180)}
	display.image{image = "assets/MFD/POPUP_PitSpeed.png",pos = vec2(150,1000), size = vec2(7856,1072)}
	display.image{image = "assets/MFD/POPUP_PitSpeedOver.png",pos = vec2(150,1000), size = vec2(7856,1072)}
	display.image{image = "assets/MFD/POPUP_BrakeBias.png",pos = vec2(150,1000), size = vec2(7856,1072)}
	display.image{image = "assets/MFD/POPUP_FuelWarning.png",pos = vec2(150,1000), size = vec2(7856,1072)}

	INITIALIZED = true

end

function update(dt)

	if TC ~= car.tractionControlMode then
		POP = 1
		TimerPOP = 0
	end

	if ABS ~= car.absMode then
		POP = 2
		TimerPOP = 0
	end

	if TimerPOP >= 2 then
		POP = 0
	else
		TimerPOP = TimerPOP + dt
	end

	if car.brakeBias ~= lastBB then
		lastBB = car.brakeBias
		POP_BB = 1
		TimerBB = 0
	end

	if TimerBB >= 2 then
		POP_BB = 0
	else
		TimerBB = TimerBB+dt
	end

	-------------------------------------------------------------------------------------------------------------------------------------------------------
	
	ABS = car.absMode
	TC = car.tractionControlMode
	rpm = car.rpm/8000
	fpl = math.floor(car.fuelPerLap)
	fpl_p = (math.floor(car.fuelPerLap*10))-(math.floor(car.fuelPerLap)*10)
	fuel = math.floor(car.fuel)
	fuel_p = (math.floor(car.fuel*10))-(math.floor(car.fuel)*10)
	GEAR = string.format(car.gear)
	Hours = string.format("%02d", math.floor(ac.getSim().timeHours)%24)
	Minutes = string.format("%02d", math.floor(ac.getSim().timeMinutes)%60)
	Seconds = string.format("%02d", math.floor(ac.getSim().timeSeconds)%60)
	laps = string.format(ac.getCar(leader).sessionLapCount)
	W_TEMP =  string.format("%.0f",car.waterTemperature)
	SPEED = math.floor(car.speedKmh)
	SPEED_P = math.floor(car.speedKmh*10)-SPEED*10
	PERF = string.format("%02d",math.abs(car.performanceMeter))
    PERF_P = string.format("%02d",(math.floor(math.abs(car.performanceMeter*100)))-(math.floor(math.abs(car.performanceMeter))*100))
	brakeBias = math.floor(string.format("%.2f",(car.brakeBias*100)))
	brakeBias_p = math.floor(math.max((string.format("%.2f",(car.brakeBias*10))*100)-brakeBias*10,0))
	OIL_TEMP =  string.format("%.0f",car.oilTemperature)
	LAP_TIME_M = string.format("%02d",math.floor(((car.lapTimeMs)/(1000*60))%60))
	LAP_TIME_S = string.format("%02d",math.floor(((car.lapTimeMs)/1000)%60))
	LAP_TIME_P = string.format("%02d",math.floor(((car.lapTimeMs)/10)%100))
	LAST_LAP_M = string.format("%02d",math.floor(((car.previousLapTimeMs)/(1000*60))%60))
	LAST_LAP_S = string.format("%02d",math.floor(((car.previousLapTimeMs)/1000)%60))
	LAST_LAP_P = string.format("%02d",math.floor(((car.previousLapTimeMs)/10)%100))
	TYRE_PRES_LF = math.floor(car.wheels[0].tyrePressure)
	TYRE_PRES_RF = math.floor(car.wheels[1].tyrePressure)
	TYRE_PRES_LR = math.floor(car.wheels[2].tyrePressure)
	TYRE_PRES_RR = math.floor(car.wheels[3].tyrePressure)
	TYRE_PRES_LF_P = string.format(math.floor((car.wheels[0].tyrePressure*10)-TYRE_PRES_LF*10))
	TYRE_PRES_RF_P = string.format(math.floor((car.wheels[1].tyrePressure*10)-TYRE_PRES_RF*10))
	TYRE_PRES_LR_P = string.format(math.floor((car.wheels[2].tyrePressure*10)-TYRE_PRES_LR*10))
	TYRE_PRES_RR_P = string.format(math.floor((car.wheels[3].tyrePressure*10)-TYRE_PRES_RR*10))

	-------------------------------------------------------------------------------------------------------------------------------------------------------
	
	if (car.gear) == -1 then
		GEAR = "R"
		elseif (car.gear) == 0 then
		GEAR = "N"
	end

	if (car.performanceMeter) >= 20 or (car.performanceMeter) <= -20 then
		PERF = "--"
		PERF_P = "--"
	end

	if (car.extraE) == false then
		page = 0
	else
		page = 1
	end
	
	if (car.lapTimeMs) <= 10000 then
		LAP_TIME_M = LAST_LAP_M
		LAP_TIME_S = LAST_LAP_S
		LAP_TIME_P = LAST_LAP_P
	end

	if car.fuel > 100 then
		slip_f = 80
	elseif car.fuel > 10 then
		slip_f = 0
	else
		slip_f = -200
	end

	if (car.manualPitsSpeedLimiterEnabled == true) or (car.isInPitlane == true) then --PitLimiter
		PitLimiter = 1
	else
		PitLimiter = 0
	end

	-------------------------------------------------------------------------------------------------------------------------------------------------------
	
	if page == 0 then
		display.image{image = "assets/MFD/PAGE_0.png",pos = vec2(0,0), size = vec2(8192,8192) }
		display.text{pos=vec2(370, 4000), letter=vec2(350, 800), text=OIL_TEMP, font="rss_gtm_5_thin", spacing=0, color=rgbm(1, 1, 1, 1), width=1050, alignment=0.5}
		display.text{pos=vec2(1990, 4000), letter=vec2(350, 800), text="95", font="rss_gtm_5_thin", spacing=0, color=rgbm(1, 1, 1, 1) }
		display.text{pos=vec2(300,5280), letter=vec2(370, 820), text=LAP_TIME_M, font="rss_gtm_5_thin", spacing=0, color=rgbm(1, 1, 1, 1) }
		display.text{pos=vec2(1290,5280), letter=vec2(370, 820), text=LAP_TIME_S, font="rss_gtm_5_thin", spacing=0, color=rgbm(1, 1, 1, 1) }
		display.text{pos=vec2(2210,5280), letter=vec2(370, 820), text=LAP_TIME_P, font="rss_gtm_5_thin", spacing=0, color=rgbm(1, 1, 1, 1) }
		display.text{pos=vec2(920,5305), letter=vec2(430, 880), text=": .", font="rss_gtm_5_thin", spacing=50, color=rgbm(1, 1, 1, 1) }
		display.text{pos=vec2(5410,5280), letter=vec2(370, 820), text=fpl, font="rss_gtm_5_thin", spacing=0, color=rgbm(1, 1, 1, 1), width=1050, alignment=1 }
		display.text{pos=vec2(5990,5280), letter=vec2(370, 820), text=fpl_p, font="rss_gtm_5_thin", spacing=0, color=rgbm(1, 1, 1, 1), width=1050, alignment=1 }
		display.text{pos=vec2(5695,5345), letter=vec2(370, 820), text=".", font="rss_gtm_5_thin", spacing=0, color=rgbm(1, 1, 1, 1), width=1050, alignment=1 }
	else
		display.image{image = "assets/MFD/PAGE_1.png",pos = vec2(0,0), size = vec2(8192,8192) }
		display.text{pos=vec2(5620+slip_f,5280), letter=vec2(370, 820), text=fuel, font="rss_gtm_5_thin", spacing=0, color=rgbm(1, 1, 1, 1), width=1050, alignment=1 }
		display.text{pos=vec2(6200+slip_f,5280), letter=vec2(370, 820), text=fuel_p, font="rss_gtm_5_thin", spacing=0, color=rgbm(1, 1, 1, 1), width=1050, alignment=1 }
		display.text{pos=vec2(5900+slip_f,5345), letter=vec2(370, 820), text=".", font="rss_gtm_5_thin", spacing=0, color=rgbm(1, 1, 1, 1), width=1050, alignment=1 }
		display.text{pos=vec2(50, 4050), letter=vec2(300, 700), text=TYRE_PRES_LF, font="rss_gtm_5_thin", spacing=0, color=rgbm(1, 1, 1, 1), width=900, alignment=1}
		display.text{pos=vec2(500, 4050), letter=vec2(300, 700), text=TYRE_PRES_LF_P, font="rss_gtm_5_thin", spacing=0, color=rgbm(1, 1, 1, 1), width=900, alignment=1}
		display.text{pos=vec2(875, 4100), letter=vec2(300, 700), text=".", font="rss_gtm_5_thin", spacing=0, color=rgbm(1, 1, 1, 1)}
		display.text{pos=vec2(50+1480, 4050), letter=vec2(300, 700), text=TYRE_PRES_RF, font="rss_gtm_5_thin", spacing=0, color=rgbm(1, 1, 1, 1), width=900, alignment=1}
		display.text{pos=vec2(500+1480, 4050), letter=vec2(300, 700), text=TYRE_PRES_RF_P, font="rss_gtm_5_thin", spacing=0, color=rgbm(1, 1, 1, 1), width=900, alignment=1}
		display.text{pos=vec2(875+1480, 4100), letter=vec2(300, 700), text=".", font="rss_gtm_5_thin", spacing=0, color=rgbm(1, 1, 1, 1)}
		display.text{pos=vec2(50, 4050+1350), letter=vec2(300, 700), text=TYRE_PRES_LR, font="rss_gtm_5_thin", spacing=0, color=rgbm(1, 1, 1, 1), width=900, alignment=1}
		display.text{pos=vec2(500, 4050+1350), letter=vec2(300, 700), text=TYRE_PRES_LR_P, font="rss_gtm_5_thin", spacing=0, color=rgbm(1, 1, 1, 1), width=900, alignment=1}
		display.text{pos=vec2(875, 4100+1350), letter=vec2(300, 700), text=".", font="rss_gtm_5_thin", spacing=0, color=rgbm(1, 1, 1, 1)}
		display.text{pos=vec2(50+1480, 4050+1350), letter=vec2(300, 700), text=TYRE_PRES_RR, font="rss_gtm_5_thin", spacing=0, color=rgbm(1, 1, 1, 1), width=900, alignment=1}
		display.text{pos=vec2(500+1480, 4050+1350), letter=vec2(300, 700), text=TYRE_PRES_RR_P, font="rss_gtm_5_thin", spacing=0, color=rgbm(1, 1, 1, 1), width=900, alignment=1}
		display.text{pos=vec2(875+1480, 4100+1350), letter=vec2(300, 700), text=".", font="rss_gtm_5_thin", spacing=0, color=rgbm(1, 1, 1, 1)}
		
	end

	-------------------------------------------------------------------------------------------------------------------------------------------------------
	
	if car.performanceMeter < 0 and car.performanceMeter > -20 then
		slip = 100
		display.text{pos= vec2 (2950+slip, 2580) , letter=vec2(380,800)   , text="-" , font="rss_gtm_5_thin", spacing =0 , color = rgbm(1, 1, 1, 1)}
	else
		slip = 0
	end

	if car.absInAction then
		display.rect{pos= vec2 (5183, 4000) , size = vec2(850,820),color = rgbm(0.96,1,0,1)}
	end

	if car.tractionControlInAction then
		display.rect{pos= vec2 (6150, 4000) , size = vec2(850,820),color = rgbm(0,0.68,0.93,1)}
	end

	-------------------------------------------------------------------------------------------------------------------------------------------------------

	display.rect{pos=vec2(370, 1625), size=vec2(7450*rpm, 445), color=rgbm(0.05, 0.51, 0.83, 1)}
	display.image{image="assets/MFD/Overlay_1.png", pos=vec2(0, 0), size=vec2(8192, 8192)}
	display.text{pos=vec2(3600, 4090), letter=vec2(1000, 2180), text=GEAR, font="rss_gtm_5_thin", spacing=-1, color=rgbm(1, 1, 1, 1)}
	display.text{pos=vec2(540, 6500), letter=vec2(280, 590), text=Hours, font="rss_gtm_5_thin", spacing=-6, color=rgbm(1, 1, 1, 1)}
	display.text{pos=vec2(1200, 6500), letter=vec2(280, 590), text=Minutes, font="rss_gtm_5_thin", spacing=-6, color=rgbm(1, 1, 1, 1)}
	display.text{pos=vec2(1870, 6500), letter=vec2(280, 590), text=Seconds, font="rss_gtm_5_thin", spacing=-6, color=rgbm(1, 1, 1, 1)}
	display.text{pos=vec2(1000, 6480), letter=vec2(280, 700), text=": :", font="rss_gtm_5_thin", spacing=60, color=rgbm(1, 1, 1, 1)}
	display.text{pos=vec2(1870, 2700), letter=vec2(350, 800), text=laps, font="rss_gtm_5_thin", spacing=0, color=rgbm(1, 1, 1, 1), width=1050, alignment=0.5}
	display.text{pos=vec2(370, 2700), letter=vec2(350, 800), text=W_TEMP, font="rss_gtm_5_thin", spacing=0, color=rgbm(1, 1, 1, 1), width=1050, alignment=0.5}
	display.text{pos=vec2(6030, 2700), letter=vec2(350, 800), text=SPEED, font="rss_gtm_5_thin", spacing=0, color=rgbm(1, 1, 1, 1), width=1050, alignment=0.5}
	display.text{pos=vec2(5070, 4055), letter=vec2(350, 800), text=ABS, font="rss_gtm_5_thin", spacing=0, color=rgbm(1, 1, 1, 1), width=1050, alignment=0.5}
	display.text{pos=vec2(6040, 4055), letter=vec2(350, 800), text=TC, font="rss_gtm_5_thin", spacing=0, color=rgbm(1, 1, 1, 1), width=1050, alignment=0.5}
	display.text{pos=vec2(7000, 4055), letter=vec2(350, 800), text="1", font="rss_gtm_5_thin", spacing=0, color=rgbm(1, 1, 1, 1), width=1050, alignment=0.5}
	display.text{pos=vec2(3240+slip, 2610), letter=vec2(380, 800), text=PERF, font="rss_gtm_5_thin", spacing=0, color=rgbm(1, 1, 1, 1)}
	display.text{pos=vec2(4200+slip, 2610), letter=vec2(380, 800), text=PERF_P, font="rss_gtm_5_thin", spacing=0, color=rgbm(1, 1, 1, 1)}
	display.text{pos=vec2(3900+slip, 2680), letter=vec2(380, 800), text=".", font="rss_gtm_5_thin", spacing=0, color=rgbm(1, 1, 1, 1)}
	
	-------------------------------------------------------------------------------------------------------------------------------------------------------

	if TC == 0 then
		display.image{image = "assets/MFD/POPUP_TCOff.png",pos = vec2(6130,3660), size = vec2(900,1180)}
	end

	if ABS == 0 then
		display.image{image = "assets/MFD/POPUP_ABSOff2.png",pos = vec2(3227,3730), size = vec2(1752,2256)}
		display.image{image = "assets/MFD/POPUP_ABSOff.png",pos = vec2(5167,3660), size = vec2(900,1180)}
	end

	if car.fuel < 5 then
		display.image{image = "assets/MFD/POPUP_FuelWarning.png",pos = vec2(150,1000), size = vec2(7856,1072)}
	end

	if car.headlightsActive == true then
		display.image{image = "assets/MFD/POPUP_LowBeam.png",pos = vec2(4030,6350), size = vec2(968,728)}
		display.image{image = "assets/MFD/POPUP_HighBeam.png",pos = vec2(5220,6390), size = vec2(968,728)}
	end
	
	if car.turningLeftLights == true then
		display.image{image = "assets/MFD/POPUP_Indicator.png",pos = vec2(2720,6470), size = vec2(536,552)}
	end

	if car.turningRightLights == true then
		display.image{image = "assets/MFD/POPUP_Indicator.png",pos = vec2(3900,6470), size = vec2(-536,552)}
	end

	if POP == 1 then
		display.image{image = "assets/MFD/POPUP_TC.png",pos = vec2(5076, 3600), size = vec2(2992,2616)}
		display.text{pos=vec2(5550, 4090), letter=vec2(1000, 2180), text=TC, font="rss_gtm_5_thin", spacing=-1, color=rgbm(0, 0, 0, 1), width=2000, alignment=0.5}
	end

	if POP == 2 then
		display.image{image = "assets/MFD/POPUP_ABS.png",pos = vec2(5076, 3600), size = vec2(2992,2616)}
		display.text{pos=vec2(5550, 4090), letter=vec2(1000, 2180), text=ABS, font="rss_gtm_5_thin", spacing=-1, color=rgbm(0, 0, 0, 1), width=2000, alignment=0.5}
	end

	if POP_BB == 1 then
		display.image{image = "assets/MFD/POPUP_BrakeBias.png",pos = vec2(150,1000), size = vec2(7856,1072)}
		display.text{pos=vec2(3200, 1330), letter=vec2(400, 800), text=brakeBias, font="rss_gtm_5_thin", spacing=0, color=rgbm(1, 1, 1, 1)}
		display.text{pos=vec2(4200, 1330), letter=vec2(400, 800), text=brakeBias_p, font="rss_gtm_5_thin", spacing=0, color=rgbm(1, 1, 1, 1)}
		display.text{pos=vec2(4600, 1330), letter=vec2(400, 800), text="0", font="rss_gtm_5_thin", spacing=0, color=rgbm(1, 1, 1, 1)}
		display.text{pos=vec2(3890, 1390), letter=vec2(400, 800), text=".", font="rss_gtm_5_thin", spacing=0, color=rgbm(1, 1, 1, 1)}
	end

	if PitLimiter == 1 then
		display.image{image = "assets/MFD/POPUP_PitSpeed.png",pos = vec2(150,1000), size = vec2(7856,1072)}
		if car.speedKmh > car.speedLimiter+1 then
			display.image{image = "assets/MFD/POPUP_PitSpeedOver.png",pos = vec2(150,1000), size = vec2(7856,1072)}
		end
		display.text{pos=vec2(5030, 1300), letter=vec2(350, 730), text=SPEED, font="rss_gtm_5_thin", spacing=-40, color=rgbm(1, 1, 1, 1),width=1050, alignment=1}
		display.text{pos=vec2(6240, 1300), letter=vec2(350, 730), text=SPEED_P, font="rss_gtm_5_thin", spacing=-40, color=rgbm(1, 1, 1, 1)}
		display.text{pos=vec2(5980, 1340), letter=vec2(350, 730), text=".", font="rss_gtm_5_thin", spacing=-40, color=rgbm(1, 1, 1, 1)}
	
	end

	if not INITIALIZED then initialize() end

end