--RSS GTM BAYER V8 LED
--Made by R_are_L https://twitter.com/R_are_L_

local TimerPL = 0
local TimerRPM = 0
local LED_RPM = {}
local PitLimiter = 0
local LED_RPM_Collar = {}
local _ac_SceneReference = nil
local LED_BLUE = ac.findNodes("carRoot:" .. car.index):findMeshes("BLUE_1"):ensureUniqueMaterials()
local LED_TC = ac.findNodes("carRoot:" .. car.index):findMeshes("YELLOW_1"):ensureUniqueMaterials()
local LED_PL = ac.findNodes("carRoot:" .. car.index):findMeshes("LED_Yellow"):ensureUniqueMaterials()
local RainLight = ac.findNodes("carRoot:" .. car.index):findMeshes("RAINLIGHT"):ensureUniqueMaterials()

function update(dt)
	TimerPL = TimerPL + dt*4
	TimerRPM = TimerRPM + dt*10

	if (car.manualPitsSpeedLimiterEnabled == true) or (car.isInPitlane == true) then --PitLimiter
		PitLimiter = 1
	else
		PitLimiter = 0
	end	

	for i = 0, 7 do
		LED_RPM[i] = ac.findNodes("carRoot:" .. car.index):findMeshes("LED_"..i):ensureUniqueMaterials()

		if i <= 3 then
			LED_RPM_Collar[i] = vec3(0,125,0)
		elseif i <= 5 then
			LED_RPM_Collar[i] = vec3(125,66,0)
		else
			LED_RPM_Collar[i] = vec3(125,0,0)
		end

		if (car.rpm - 5000) >= (170*i) then
			LED_RPM[i]:setMaterialProperty("ksEmissive", LED_RPM_Collar[i])
		end

		if car.rpm > 6400 then
			if math.fmod(math.floor(TimerRPM), 2) == 1 then
				LED_RPM[i]:setMaterialProperty("ksEmissive", vec3(0, 0, 0))
			end
		end

		if PitLimiter == 1 then
			LED_RPM[i]:setMaterialProperty("ksEmissive", vec3(0,0,0))
			if i == 3 then
				LED_RPM[i]:setMaterialProperty("ksEmissive", vec3(0,125,0))
			end
			if i == 4 then
				LED_RPM[i]:setMaterialProperty("ksEmissive", vec3(0,125,0))
			end
		end
		
		if car.tractionControlInAction then
			LED_TC:setMaterialProperty("ksEmissive", vec3(125,66,0))
		else
			LED_TC:setMaterialProperty("ksEmissive", vec3(0,0,0))
		end

	end
	
	if car.extraA then
		RainLight:setMaterialProperty("ksEmissive", vec3(800,0.0))
	else 
		RainLight:setMaterialProperty("ksEmissive", vec3(0, 0, 0))
	end

	if PitLimiter == 1 then
		LED_BLUE:setMaterialProperty("ksEmissive", vec3(0,0,333))
		LED_PL:setMaterialProperty("ksEmissive", vec3(300, 275, 0))
		RainLight:setMaterialProperty("ksEmissive", vec3(800,0.0))
		if math.fmod(math.floor(TimerPL), 2) == 1 then
			RainLight:setMaterialProperty("ksEmissive", vec3(0, 0, 0))
		end
	else
		LED_BLUE:setMaterialProperty("ksEmissive", vec3(0, 0, 0))
		LED_PL:setMaterialProperty("ksEmissive", vec3(0, 0, 0))
	end

end