--RSS GTM LANZO V10 EVO2 MFD 
--Made by R_are_L https://twitter.com/R_are_L_

local page = 1
local LastExtraE = (car.extraE)
local Red = rgbm(64, 0, 0, 1)
local Black = rgbm(0, 0, 0, 1)
local White = rgbm(1, 1, 1, 1)
local Blue = rgbm(0, 0.56, 1, 1)
local Green = rgbm(0, 0.78, 0, 1)
local Fuel_COLOR = rgbm(0, 0.78, 0, 1)
local PERF_bar_Collar = rgbm(0, 0, 0, 1)
local TYRE_P_COLOR = {}
local TYRE_T_COLOR = {}
local GEAR = 0
local ABS = 0
local TC = 0
local RPM = 0
local SPEED = 0
local fpl = 0
local fpl_p = 0
local fuel = 0
local fuel_p = 0
local LAP_TIME_M = 0
local LAP_TIME_S = 0
local LAP_TIME_P = 0
local LAST_LAP_M = 0
local LAST_LAP_S = 0
local LAST_LAP_P = 0
local PERF = 0
local PERF_P = 0
local PERF_B = 0
local OIL_TEMP =  0
local W_TEMP =  0
local TYRE_PRES_LF = 0
local TYRE_PRES_RF = 0
local TYRE_PRES_LR = 0
local TYRE_PRES_RR = 0
local TYRE_PRES_LF_P = 0
local TYRE_PRES_RF_P = 0
local TYRE_PRES_LR_P = 0
local TYRE_PRES_RR_P = 0
local TYRE_TEMP_LF = 0
local TYRE_TEMP_RF = 0
local TYRE_TEMP_LR = 0
local TYRE_TEMP_RR = 0
local brakeBias = 0
local brakeBias_p = 0
local lastBB = car.brakeBias
local TimerBB = 0
local PitLimiter = 0

local function initialize()

	display.image{image = "assets/MFD/P1.png",pos = vec2(0,0), size = vec2(8192,8192)}
	display.image{image = "assets/MFD/P2.png",pos = vec2(0,0), size = vec2(8192,8192)}
	display.image{image = "assets/MFD/P3.png",pos = vec2(0,0), size = vec2(8192,8192)}
	display.image{image = "assets/MFD/P4.png",pos = vec2(0,0), size = vec2(8192,8192)}
	display.image{image = "assets/MFD/P2_Overlay.png",pos = vec2(0,0), size = vec2(8192,8192)}
	display.image{image = "assets/MFD/P4_Overlay.png",pos = vec2(0,0), size = vec2(8192,8192)}
	display.image{image = "assets/MFD/POPUP_TC_OFF.png",pos = vec2(20,1030), size = vec2(1392,1256)}
	display.image{image = "assets/MFD/POPUP_ABS_OFF.png",pos = vec2(6770,1030), size = vec2(1392,1256)}
	display.image{image = "assets/MFD/POPUP_BrakeBias.png",pos = vec2(40,5130), size = vec2(8112,1096)}
	display.image{image = "assets/MFD/POPUP_PitSpeed.png",pos = vec2(40,4070), size = vec2(8112,1096)}
	display.image{image = "assets/MFD/POPUP_FuelWarn.png",pos = vec2(0,5900), size = vec2(8192,1280)}
	display.image{image = "assets/MFD/Popup_TC.png",pos = vec2(25,1030), size = vec2(1040,1256)}
	display.image{image = "assets/MFD/Popup_ABS.png",pos = vec2(7130,1030), size = vec2(1040,1256)}

	INITIALIZED = true

end

function update(dt)
	
	if car.brakeBias ~= lastBB then
		lastBB = car.brakeBias
		POP_BB = 1
		TimerBB = 0
	end

	if TimerBB >= 2 then
		POP_BB = 0
	else
		TimerBB = TimerBB+dt
	end

	---------------------------------------------------------------------------------------------------------------------------

	GEAR = string.format(car.gear)
	ABS = car.absMode
	TC = car.tractionControlMode
	RPM = string.format("%.f",car.rpm)
	SPEED = string.format("%.0f",car.speedKmh)
	fpl = math.floor(car.fuelPerLap)
	fpl_p = (math.floor(car.fuelPerLap*10))-(math.floor(car.fuelPerLap)*10)
	fuel = math.floor(car.fuel)
	fuel_p = (math.floor(car.fuel*10))-(math.floor(car.fuel)*10)
	LAP_TIME_M = string.format("%02d",math.floor(((car.lapTimeMs)/(1000*60))%60))
	LAP_TIME_S = string.format("%02d",math.floor(((car.lapTimeMs)/1000)%60))
	LAP_TIME_P = string.format("%02d",math.floor(((car.lapTimeMs)/10)%100))
	LAST_LAP_M = string.format("%02d",math.floor(((car.previousLapTimeMs)/(1000*60))%60))
	LAST_LAP_S = string.format("%02d",math.floor(((car.previousLapTimeMs)/1000)%60))
	LAST_LAP_P = string.format("%02d",math.floor(((car.previousLapTimeMs)/10)%100))
	PERF = string.format("%02d",math.abs(car.performanceMeter))
    PERF_P = string.format("%02d",(math.floor(math.abs(car.performanceMeter*100)))-(math.floor(math.abs(car.performanceMeter))*100))
	PERF_B = math.max(0,(math.min(1.8,(car.performanceMeter+1))))
	OIL_TEMP =  string.format("%.0f",car.oilTemperature)
	W_TEMP =  string.format("%.0f",car.waterTemperature)
	TYRE_PRES_LF = math.floor(car.wheels[0].tyrePressure)
	TYRE_PRES_RF = math.floor(car.wheels[1].tyrePressure)
	TYRE_PRES_LR = math.floor(car.wheels[2].tyrePressure)
	TYRE_PRES_RR = math.floor(car.wheels[3].tyrePressure)
	TYRE_PRES_LF_P = string.format(math.floor((car.wheels[0].tyrePressure*10)-TYRE_PRES_LF*10))
	TYRE_PRES_RF_P = string.format(math.floor((car.wheels[1].tyrePressure*10)-TYRE_PRES_RF*10))
	TYRE_PRES_LR_P = string.format(math.floor((car.wheels[2].tyrePressure*10)-TYRE_PRES_LR*10))
	TYRE_PRES_RR_P = string.format(math.floor((car.wheels[3].tyrePressure*10)-TYRE_PRES_RR*10))
	TYRE_TEMP_LF = string.format("%.0f",car.wheels[0].tyreTemperature)
	TYRE_TEMP_RF = string.format("%.0f",car.wheels[1].tyreTemperature)
	TYRE_TEMP_LR = string.format("%.0f",car.wheels[2].tyreTemperature)
	TYRE_TEMP_RR = string.format("%.0f",car.wheels[3].tyreTemperature)
	brakeBias = math.floor(string.format("%.2f",(car.brakeBias*100)))
	brakeBias_p = math.floor(math.max((string.format("%.2f",(car.brakeBias*10))*100)-brakeBias*10,0))

	---------------------------------------------------------------------------------------------------------------------------
	
	if (car.gear) == -1 then
		GEAR = "R"
		elseif (car.gear) == 0 then
		GEAR = "N"
	end

	if LastExtraE ~= (car.extraE) then
		LastExtraE = (car.extraE)
		if page == 4 then
			page = 0
		end
		page = page +1
	end
	
	if (car.lapTimeMs) <= 10000 then
		LAP_TIME_M = LAST_LAP_M
		LAP_TIME_S = LAST_LAP_S
		LAP_TIME_P = LAST_LAP_P
	end

	
	if (car.performanceMeter) >= 20 or (car.performanceMeter) <= -20 then
		PERF = "--"
		PERF_P = "--"
	end

	if car.performanceMeter < 0 and car.performanceMeter > -20 then
		PERF = "-"..PERF
	else
		PERF = PERF
	end

	if car.performanceMeter > 0 then
		PERF_bar_Collar = rgbm(0.74, 0, 0, 1)
	else
		PERF_bar_Collar = rgbm(0.15, 0.28, 1, 1)
	end

	if car.fuel > 5 then
		Fuel_COLOR = Green
	else
		Fuel_COLOR = Red
	end

	if car.fuel < 10 and page == 4 then
		fuel = "0"..fuel
	else
		fuel = fuel
	end

	if string.len(fuel) == 1 then
		slip = -145
	elseif string.len(fuel) == 2 then
		slip = 0
	else
		slip = 145
	end

	for i=0,3 do
		if car.wheels[i].tyrePressure > 32 then
			TYRE_P_COLOR[i] = Red
		elseif car.wheels[i].tyrePressure > 25.5 then
			TYRE_P_COLOR[i] = Green
		else
			TYRE_P_COLOR[i] = Blue
		end

		if car.wheels[i].tyreTemperature > 120 then
			TYRE_T_COLOR[i] = Red
		elseif car.wheels[i].tyreTemperature > 80 then
			TYRE_T_COLOR[i] = Green
		else
			TYRE_T_COLOR[i] = Blue
		end
	end
	
	if (car.manualPitsSpeedLimiterEnabled == true) or (car.isInPitlane == true) then --PitLimiter
		PitLimiter = 1
	else
		PitLimiter = 0
	end
	---------------------------------------------------------------------------------------------------------------------------
	
	if page == 1 then

		display.image{image = "assets/MFD/P1.png",pos = vec2(0,0), size = vec2(8192,8192)}
		display.text{pos=vec2(3820, 1520), letter=vec2(500, 1380), text=GEAR, font="rss_gtm_5_thin", spacing=0, color=Black }
		display.text{pos=vec2(2470, 1530), letter=vec2(300, 800), text="1", font="rss_gtm_5_thin", spacing=0, color=Black }
		display.text{pos=vec2(1400, 1530), letter=vec2(300, 800), text="2", font="rss_gtm_5_thin", spacing=0, color=Black }
		display.text{pos=vec2(400, 1530), letter=vec2(300, 800), text=TC, font="rss_gtm_5_thin", spacing=0, color=Black }
		display.text{pos=vec2(5480, 1530), letter=vec2(300, 800), text="1", font="rss_gtm_5_thin", spacing=0, color=Black }
		display.text{pos=vec2(6480, 1530), letter=vec2(300, 800), text="0", font="rss_gtm_5_thin", spacing=0, color=Black }
		display.text{pos=vec2(7350, 1530), letter=vec2(300, 800), text=ABS, font="rss_gtm_5_thin", spacing=0, color=Black, width=600, alignment=0.5 }
		display.text{pos=vec2(2080, 3150), letter=vec2(500, 1250), text=SPEED, font="rss_gtm_5_thin", spacing=0, color=Black, width=1500, alignment=0.5 }
		display.text{pos=vec2(4530, 3220), letter=vec2(410, 1000), text=RPM, font="rss_gtm_5_thin", spacing=0, color=Black , width=1640, alignment=0.5 }
		display.text{pos=vec2(250, 4810), letter=vec2(410, 1000), text=LAP_TIME_M, font="rss_gtm_5_thin", spacing=0, color=Black}
		display.text{pos=vec2(1250, 4810), letter=vec2(410, 1000), text=LAP_TIME_S, font="rss_gtm_5_thin", spacing=0, color=Black}
		display.text{pos=vec2(2260, 4810), letter=vec2(410, 1000), text=LAP_TIME_P, font="rss_gtm_5_thin", spacing=0, color=Black}
		display.text{pos=vec2(920, 4810), letter=vec2(500, 1100), text=": .", font="rss_gtm_5_thin", spacing=0, color=Black}
		display.text{pos=vec2(5170, 4810), letter=vec2(410, 1000), text=PERF, font="rss_gtm_5_thin", spacing=0, color=Black, width=1230, alignment=1 }
		display.text{pos=vec2(6570, 4810), letter=vec2(410, 1000), text=PERF_P, font="rss_gtm_5_thin", spacing=0, color=Black}
		display.text{pos=vec2(6240, 4830), letter=vec2(500, 1100), text=".", font="rss_gtm_5_thin", spacing=0, color=Black}
		display.text{pos=vec2(600, 6400), letter=vec2(240, 640), text="84", font="rss_gtm_5_thin", spacing=0, color=Black }
		display.text{pos=vec2(2230, 6400), letter=vec2(240, 640), text=OIL_TEMP, font="rss_gtm_5_thin", spacing=0, color=Black }
		display.text{pos=vec2(3860, 6400), letter=vec2(240, 640), text=W_TEMP, font="rss_gtm_5_thin", spacing=0, color=Black }
		display.text{pos=vec2(5300, 6400), letter=vec2(240, 640), text=fpl, font="rss_gtm_5_thin", spacing=0, color=Black }
		display.text{pos=vec2(5680, 6400), letter=vec2(240, 640), text=fpl_p, font="rss_gtm_5_thin", spacing=0, color=Black }
		display.text{pos=vec2(5460, 6450), letter=vec2(300, 640), text=".", font="rss_gtm_5_thin", spacing=0, color=Black }
		display.text{pos=vec2(6440, 6400), letter=vec2(290, 640), text=fuel, font="rss_gtm_5_thin", spacing=0, color=Black , width=870, alignment=1 }
		display.text{pos=vec2(7480, 6400), letter=vec2(290, 640), text=fuel_p, font="rss_gtm_5_thin", spacing=0, color=Black }
		display.text{pos=vec2(7240, 6450), letter=vec2(300, 640), text=".", font="rss_gtm_5_thin", spacing=0, color=Black }
		
	elseif page == 2 then

		display.image{image = "assets/MFD/P2.png",pos = vec2(0,0), size = vec2(8192,8192)}
		display.rect{pos=vec2(1300, 3520), size=vec2(1600, 1220), color=TYRE_P_COLOR[0]}
		display.rect{pos=vec2(5320, 3520), size=vec2(1600, 1220), color=TYRE_P_COLOR[1]}
		display.rect{pos=vec2(1300, 4780), size=vec2(1600, 1220), color=TYRE_P_COLOR[2]}
		display.rect{pos=vec2(5320, 4780), size=vec2(1600, 1220), color=TYRE_P_COLOR[3]}
		display.rect{pos=vec2(320, 6660), size=vec2(3800*PERF_B, 410), color=PERF_bar_Collar}
		display.text{pos=vec2(3680, 4000), letter=vec2(900, 2360), text=GEAR, font="rss_gtm_5_thin", spacing=0, color=White }
		display.text{pos=vec2(3520, 2650), letter=vec2(370, 880), text=SPEED, font="rss_gtm_5_thin", spacing=-15, color=White , width=1110, alignment=0.5 }
		display.text{pos=vec2(3400, 1370), letter=vec2(370, 880), text=RPM, font="rss_gtm_5_thin", spacing=-25, color=White , width=1345, alignment=0.5 }
		display.text{pos=vec2(280, 2680), letter=vec2(370, 880), text=LAP_TIME_M, font="rss_gtm_5_thin", spacing=-15, color=White}
		display.text{pos=vec2(1120, 2680), letter=vec2(370, 880), text=LAP_TIME_S, font="rss_gtm_5_thin", spacing=-15, color=White}
		display.text{pos=vec2(1980, 2680), letter=vec2(370, 880), text=LAP_TIME_P, font="rss_gtm_5_thin", spacing=-15, color=White}
		display.text{pos=vec2(800, 2630), letter=vec2(500, 1050), text=": .", font="rss_gtm_5_thin", spacing=-80, color=White}
		display.text{pos=vec2(5530, 2680), letter=vec2(370, 880), text=PERF, font="rss_gtm_5_thin", spacing=-15, color=White, width=1110, alignment=1 }
		display.text{pos=vec2(6820, 2680), letter=vec2(370, 880), text=PERF_P, font="rss_gtm_5_thin", spacing=-15, color=White}
		display.text{pos=vec2(6480, 2630), letter=vec2(500, 1050), text=".", font="rss_gtm_5_thin", spacing=0, color=White}
		display.text{pos=vec2(430, 1370), letter=vec2(370, 880), text=TC, font="rss_gtm_5_thin", spacing=0, color=White}
		display.text{pos=vec2(1700, 1370), letter=vec2(370, 880), text="2", font="rss_gtm_5_thin", spacing=0, color=White}
		display.text{pos=vec2(6120, 1370), letter=vec2(370, 880), text="1", font="rss_gtm_5_thin", spacing=0, color=White}
		display.text{pos=vec2(7190, 1370), letter=vec2(370, 880), text=ABS, font="rss_gtm_5_thin", spacing=0, color=White, width=740, alignment=0.5 }
		display.text{pos=vec2(1400, 3800), letter=vec2(370, 880), text=TYRE_PRES_LF, font="rss_gtm_5_thin", spacing=0, color=Black, width=740, alignment=0.5 }
		display.text{pos=vec2(2200, 3800), letter=vec2(370, 880), text=TYRE_PRES_LF_P, font="rss_gtm_5_thin", spacing=0, color=Black, width=740, alignment=0.5 }
		display.text{pos=vec2(1930, 3840), letter=vec2(400, 880), text=".", font="rss_gtm_5_thin", spacing=0, color=Black, width=740, alignment=0.5 }
		display.text{pos=vec2(1400, 5050), letter=vec2(370, 880), text=TYRE_PRES_LR, font="rss_gtm_5_thin", spacing=0, color=Black, width=740, alignment=0.5 }
		display.text{pos=vec2(2200, 5050), letter=vec2(370, 880), text=TYRE_PRES_LR_P, font="rss_gtm_5_thin", spacing=0, color=Black, width=740, alignment=0.5 }
		display.text{pos=vec2(1930, 5090), letter=vec2(400, 880), text=".", font="rss_gtm_5_thin", spacing=0, color=Black, width=740, alignment=0.5 }
		display.text{pos=vec2(5400, 3800), letter=vec2(370, 880), text=TYRE_PRES_RF, font="rss_gtm_5_thin", spacing=0, color=Black, width=740, alignment=0.5 }
		display.text{pos=vec2(6200, 3800), letter=vec2(370, 880), text=TYRE_PRES_RF_P, font="rss_gtm_5_thin", spacing=0, color=Black, width=740, alignment=0.5 }
		display.text{pos=vec2(5930, 3840), letter=vec2(400, 880), text=".", font="rss_gtm_5_thin", spacing=0, color=Black, width=740, alignment=0.5 }
		display.text{pos=vec2(5400, 5050), letter=vec2(370, 880), text=TYRE_PRES_RR, font="rss_gtm_5_thin", spacing=0, color=Black, width=740, alignment=0.5 }
		display.text{pos=vec2(6200, 5050), letter=vec2(370, 880), text=TYRE_PRES_RR_P, font="rss_gtm_5_thin", spacing=0, color=Black, width=740, alignment=0.5 }
		display.text{pos=vec2(5930, 5090), letter=vec2(400, 880), text=".", font="rss_gtm_5_thin", spacing=0, color=Black, width=740, alignment=0.5 }
		display.image{image = "assets/MFD/P2_Overlay.png",pos = vec2(0,0), size = vec2(8192,8192)}
	elseif page == 3 then

		display.image{image = "assets/MFD/P3.png",pos = vec2(0,0), size = vec2(8192,8192)}
		display.text{pos=vec2(3820, 1520), letter=vec2(500, 1380), text=GEAR, font="rss_gtm_5_thin", spacing=0, color=White }
		display.text{pos=vec2(2470, 1530), letter=vec2(300, 800), text="1", font="rss_gtm_5_thin", spacing=0, color=White }
		display.text{pos=vec2(1400, 1530), letter=vec2(300, 800), text="2", font="rss_gtm_5_thin", spacing=0, color=White }
		display.text{pos=vec2(400, 1530), letter=vec2(300, 800), text=TC, font="rss_gtm_5_thin", spacing=0, color=White }
		display.text{pos=vec2(5480, 1530), letter=vec2(300, 800), text="1", font="rss_gtm_5_thin", spacing=0, color=White }
		display.text{pos=vec2(6480, 1530), letter=vec2(300, 800), text="0", font="rss_gtm_5_thin", spacing=0, color=White }
		display.text{pos=vec2(7350, 1530), letter=vec2(300, 800), text=ABS, font="rss_gtm_5_thin", spacing=0, color=White, width=600, alignment=0.5 }
		display.text{pos=vec2(2080, 3150), letter=vec2(500, 1250), text=SPEED, font="rss_gtm_5_thin", spacing=0, color=White, width=1500, alignment=0.5 }
		display.text{pos=vec2(4530, 3220), letter=vec2(410, 1000), text=RPM, font="rss_gtm_5_thin", spacing=0, color=White , width=1640, alignment=0.5 }
		display.text{pos=vec2(250, 4810), letter=vec2(410, 1000), text=LAP_TIME_M, font="rss_gtm_5_thin", spacing=0, color=White}
		display.text{pos=vec2(1250, 4810), letter=vec2(410, 1000), text=LAP_TIME_S, font="rss_gtm_5_thin", spacing=0, color=White}
		display.text{pos=vec2(2260, 4810), letter=vec2(410, 1000), text=LAP_TIME_P, font="rss_gtm_5_thin", spacing=0, color=White}
		display.text{pos=vec2(920, 4810), letter=vec2(500, 1100), text=": .", font="rss_gtm_5_thin", spacing=0, color=White}
		display.text{pos=vec2(5170, 4810), letter=vec2(410, 1000), text=PERF, font="rss_gtm_5_thin", spacing=0, color=White, width=1230, alignment=1 }
		display.text{pos=vec2(6570, 4810), letter=vec2(410, 1000), text=PERF_P, font="rss_gtm_5_thin", spacing=0, color=White}
		display.text{pos=vec2(6240, 4830), letter=vec2(500, 1100), text=".", font="rss_gtm_5_thin", spacing=0, color=White}
		display.text{pos=vec2(600, 6400), letter=vec2(240, 640), text="84", font="rss_gtm_5_thin", spacing=0, color=White }
		display.text{pos=vec2(2230, 6400), letter=vec2(240, 640), text=OIL_TEMP, font="rss_gtm_5_thin", spacing=0, color=White }
		display.text{pos=vec2(3860, 6400), letter=vec2(240, 640), text=W_TEMP, font="rss_gtm_5_thin", spacing=0, color=White }
		display.text{pos=vec2(5300, 6400), letter=vec2(240, 640), text=fpl, font="rss_gtm_5_thin", spacing=0, color=White }
		display.text{pos=vec2(5680, 6400), letter=vec2(240, 640), text=fpl_p, font="rss_gtm_5_thin", spacing=0, color=White }
		display.text{pos=vec2(5460, 6450), letter=vec2(300, 640), text=".", font="rss_gtm_5_thin", spacing=0, color=White }
		display.text{pos=vec2(6440+slip, 6400), letter=vec2(290, 640), text=fuel, font="rss_gtm_5_thin", spacing=0, color=Black , width=870, alignment=1 }
		display.text{pos=vec2(7480+slip, 6400), letter=vec2(290, 640), text=fuel_p, font="rss_gtm_5_thin", spacing=0, color=Black }
		display.text{pos=vec2(7240+slip, 6450), letter=vec2(300, 640), text=".", font="rss_gtm_5_thin", spacing=0, color=Black }
	elseif page == 4 then

		display.image{image = "assets/MFD/P4.png",pos = vec2(0,0), size = vec2(8192,8192)}
		display.rect{pos=vec2(0, 3420), size=vec2(1600, 1220), color=TYRE_P_COLOR[0]}
		display.rect{pos=vec2(0, 4680), size=vec2(1600, 1220), color=TYRE_P_COLOR[2]}
		display.rect{pos=vec2(6600, 3420), size=vec2(1600, 1220), color=TYRE_P_COLOR[1]}
		display.rect{pos=vec2(6600, 4680), size=vec2(1600, 1220), color=TYRE_P_COLOR[3]}
		display.rect{pos=vec2(1630, 3835), size=vec2(1210, 805), color=TYRE_T_COLOR[0]}
		display.rect{pos=vec2(1630, 4685), size=vec2(1210, 805), color=TYRE_T_COLOR[2]}
		display.rect{pos=vec2(5350, 3835), size=vec2(1210, 805), color=TYRE_T_COLOR[1]}
		display.rect{pos=vec2(5350, 4685), size=vec2(1210, 805), color=TYRE_T_COLOR[3]}
		display.rect{pos=vec2(4900, 5920), size=vec2(3300, 1250), color=Fuel_COLOR}
		display.text{pos=vec2(2470, 1530), letter=vec2(300, 800), text="1", font="rss_gtm_5_thin", spacing=0, color=White }
		display.text{pos=vec2(1400, 1530), letter=vec2(300, 800), text="2", font="rss_gtm_5_thin", spacing=0, color=White }
		display.text{pos=vec2(400, 1530), letter=vec2(300, 800), text=TC, font="rss_gtm_5_thin", spacing=0, color=White }
		display.text{pos=vec2(5480, 1530), letter=vec2(300, 800), text="1", font="rss_gtm_5_thin", spacing=0, color=White }
		display.text{pos=vec2(6480, 1530), letter=vec2(300, 800), text="0", font="rss_gtm_5_thin", spacing=0, color=White }
		display.text{pos=vec2(7350, 1530), letter=vec2(300, 800), text=ABS, font="rss_gtm_5_thin", spacing=0, color=White, width=600, alignment=0.5 }
		display.text{pos=vec2(600, 6400), letter=vec2(240, 640), text="84", font="rss_gtm_5_thin", spacing=0, color=White }
		display.text{pos=vec2(2230, 6400), letter=vec2(240, 640), text=OIL_TEMP, font="rss_gtm_5_thin", spacing=0, color=White }
		display.text{pos=vec2(3860, 6400), letter=vec2(240, 640), text=W_TEMP, font="rss_gtm_5_thin", spacing=0, color=White }
		display.text{pos=vec2(5670+slip, 6400), letter=vec2(290, 640), text=fuel, font="rss_gtm_5_thin", spacing=0, color=Black ,width=870, alignment=1  }
		display.text{pos=vec2(6700+slip, 6400), letter=vec2(290, 640), text=fuel_p, font="rss_gtm_5_thin", spacing=0, color=Black }
		display.text{pos=vec2(6475+slip, 6450), letter=vec2(290, 640), text=".", font="rss_gtm_5_thin", spacing=0, color=Black }
		display.text{pos=vec2(3600, 3620), letter=vec2(1000, 2480), text=GEAR, font="rss_gtm_5_thin", spacing=0, color=White }
		display.text{pos=vec2(3400, 1490), letter=vec2(370, 880), text=RPM, font="rss_gtm_5_thin", spacing=-35, color=White , width=1345, alignment=0.5 }
		display.text{pos=vec2(3560, 2410), letter=vec2(340, 840), text=SPEED, font="rss_gtm_5_thin", spacing=-5, color=Black , width=1020, alignment=0.5 }
		display.text{pos=vec2(140, 2650), letter=vec2(310, 880), text=LAP_TIME_M, font="rss_gtm_5_thin", spacing=0, color=White }
		display.text{pos=vec2(890, 2650), letter=vec2(310, 880), text=LAP_TIME_S, font="rss_gtm_5_thin", spacing=0, color=White }
		display.text{pos=vec2(1650, 2650), letter=vec2(310, 880), text=LAP_TIME_P, font="rss_gtm_5_thin", spacing=0, color=White }
		display.text{pos=vec2(605, 2700), letter=vec2(440, 880), text=": .", font="rss_gtm_5_thin", spacing=-65, color=White }
		display.text{pos=vec2(5970, 2650), letter=vec2(310, 860), text=PERF, font="rss_gtm_5_thin", spacing=0, color=White , width=930, alignment=1 }
		display.text{pos=vec2(6720, 2650), letter=vec2(310, 860), text=PERF_P, font="rss_gtm_5_thin", spacing=0, color=White , width=930, alignment=1 }
		display.text{pos=vec2(6255, 2710), letter=vec2(430, 860), text=".", font="rss_gtm_5_thin", spacing=0, color=White , width=930, alignment=1 }
		display.text{pos=vec2(1770, 3990), letter=vec2(300, 630), text=TYRE_TEMP_LF, font="rss_gtm_5_thin", spacing=0, color=Black , width=900, alignment=0.5 }
		display.text{pos=vec2(1770, 4850), letter=vec2(300, 630), text=TYRE_TEMP_LR, font="rss_gtm_5_thin", spacing=0, color=Black , width=900, alignment=0.5 }
		display.text{pos=vec2(5510, 3990), letter=vec2(300, 630), text=TYRE_TEMP_RF, font="rss_gtm_5_thin", spacing=0, color=Black , width=900, alignment=0.5 }
		display.text{pos=vec2(5510, 4850), letter=vec2(300, 630), text=TYRE_TEMP_RR, font="rss_gtm_5_thin", spacing=0, color=Black , width=900, alignment=0.5 }
		display.text{pos=vec2(240, 3850), letter=vec2(320, 700), text=TYRE_PRES_LF, font="rss_gtm_5_thin", spacing=0, color=Black}
		display.text{pos=vec2(1050, 3850), letter=vec2(320, 700), text=TYRE_PRES_LF_P, font="rss_gtm_5_thin", spacing=0, color=Black}
		display.text{pos=vec2(785, 3900), letter=vec2(350, 700), text=".", font="rss_gtm_5_thin", spacing=0, color=Black}
		display.text{pos=vec2(240, 5100), letter=vec2(320, 700), text=TYRE_PRES_LR, font="rss_gtm_5_thin", spacing=0, color=Black}
		display.text{pos=vec2(1050, 5100), letter=vec2(320, 700), text=TYRE_PRES_LR_P, font="rss_gtm_5_thin", spacing=0, color=Black}
		display.text{pos=vec2(785, 5150), letter=vec2(350, 700), text=".", font="rss_gtm_5_thin", spacing=0, color=Black}
		display.text{pos=vec2(6810, 3850), letter=vec2(320, 700), text=TYRE_PRES_RF, font="rss_gtm_5_thin", spacing=0, color=Black}
		display.text{pos=vec2(7620, 3850), letter=vec2(320, 700), text=TYRE_PRES_RF_P, font="rss_gtm_5_thin", spacing=0, color=Black}
		display.text{pos=vec2(7355, 3900), letter=vec2(350, 700), text=".", font="rss_gtm_5_thin", spacing=0, color=Black}
		display.text{pos=vec2(6810, 5100), letter=vec2(320, 700), text=TYRE_PRES_RR, font="rss_gtm_5_thin", spacing=0, color=Black}
		display.text{pos=vec2(7620, 5100), letter=vec2(320, 700), text=TYRE_PRES_RR_P, font="rss_gtm_5_thin", spacing=0, color=Black}
		display.text{pos=vec2(7355, 5150), letter=vec2(350, 700), text=".", font="rss_gtm_5_thin", spacing=0, color=Black}
		display.image{image = "assets/MFD/P4_Overlay.png",pos = vec2(0,0), size = vec2(8192,8192)}

	end

	if POP_BB == 1 then
		display.image{image = "assets/MFD/POPUP_BrakeBias.png",pos = vec2(40,5130), size = vec2(8112,1096)}
		display.text{pos=vec2(3650, 5500), letter=vec2(250, 660), text=brakeBias, font="rss_gtm_5_thin", spacing=0, color=White }
		display.text{pos=vec2(4270, 5500), letter=vec2(250, 660), text=brakeBias_p, font="rss_gtm_5_thin", spacing=0, color=White }
		display.text{pos=vec2(4050, 5560), letter=vec2(315, 630), text=".", font="rss_gtm_5_thin", spacing=0, color=White }
	end

	if PitLimiter == 1 then
		display.image{image = "assets/MFD/POPUP_PitSpeed.png",pos = vec2(40,4070), size = vec2(8112,1096)}
	end

	if TC == 0 then
		display.image{image = "assets/MFD/POPUP_TC_OFF.png",pos = vec2(20,1030), size = vec2(1392,1256)}
	end
	
	if ABS == 0 then
		display.image{image = "assets/MFD/POPUP_ABS_OFF.png",pos = vec2(6770,1030), size = vec2(1392,1256)}
	end
	
	if car.absInAction then
		display.image{image = "assets/MFD/Popup_ABS.png",pos = vec2(7130,1030), size = vec2(1040,1256)}
	end

	if car.tractionControlInAction then
		display.image{image = "assets/MFD/Popup_TC.png",pos = vec2(25,1030), size = vec2(1040,1256)}
	end

	if car.fuel < 4 then
		display.image{image = "assets/MFD/POPUP_FuelWarn.png",pos = vec2(0,5900), size = vec2(8192,1280)}
	end

	if not INITIALIZED then initialize() end

end